﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;
using HBLConsole.DialogWindow.View;
using HBLConsole.View;
using System.Diagnostics;
using HBLConsole.Service;
using HBLConsole.Model;
using HBLConsole.MainConsole;
using HBLConsole.GVL;
using BPA.Message.Enum;
using HBLConsole.Business;

namespace HBLConsole
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        MainView mainView = new MainView();
        ListDialogView listDialogView;
        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);
            SystemHelper.GetInstance.AutoStart(false);
            SystemHelper.GetInstance.CreateDesktopShortcut();
            AppDomain.CurrentDomain.UnhandledException += CurrentDomain_UnhandledException;
            MainConsole.Main.GetInstance.DataInit();
            ThreadOperate.GetInstance.Start(new Action(() => { SqlHelper.GetInstance.GetData(); }), "GetSqliteData");
            mainView.Show();
            NoCompleteOrderInit();
            MainConsole.Main.GetInstance.BusinessInit();
        }

        /// <summary>
        /// 未完成订单初始化
        /// </summary>
        private void NoCompleteOrderInit()
        {
            if (Json<KeepDataBase>.Data.orderLists.ContainsKey(GeneralConfig.DeviceType.ToString()))
            {
                if (Json<KeepDataBase>.Data.orderLists[GeneralConfig.DeviceType.ToString()].Count > 0)
                {
                    listDialogView = new ListDialogView();
                    listDialogView.ShowDialog();
                }
            }
        }

        private void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            SqlHelper.GetInstance.Save();
            MainConsole.Main.GetInstance.DataSave();
            Process.Start($"{AppDomain.CurrentDomain.BaseDirectory}{AppDomain.CurrentDomain.FriendlyName}.exe");
        }

        protected override void OnExit(ExitEventArgs e)
        {
            base.OnExit(e);
            IotReport.Close();
            SqlHelper.GetInstance.Save();
            MainConsole.Main.GetInstance.DataSave();
            ThreadOperate.GetInstance.Dispose();
            System.Environment.Exit(0);

        }
    }
}
