﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Toolkit.Mvvm.Input;
using HBLConsole.Service;
using System.Threading;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using HBLConsole.Communication;
using HBLConsole.Model;
using System.Reflection;
using System.Collections.Concurrent;
using HBLConsole.Attributes;
using System.Collections.ObjectModel;
using System.Windows.Media;
using HBLConsole.DialogWindow.View;

namespace HBLConsole.ViewModel
{
    public class DebugViewModel : ViewModelBase
    {
        public DebugViewModel()
        {
            WindowName = "调试模式";

            AddSimDataCommand = new RelayCommand(() =>
            {
                SimOrderConfitView simOrderConfitView = new SimOrderConfitView();
                simOrderConfitView.ShowDialog();
            });

            SimOrderCommand = new RelayCommand(() =>
            {
                List<ushort> locs = new List<ushort>();
                foreach (var item in simOrderConfig)
                {
                    if (item.IsSelected)
                        locs.Add((ushort)(new Random().Next(item.MinValue, item.MaxValue + 1)));
                    else
                        locs.Add(item.Loc);
                }
                if (locs.Count == 0)
                {
                    locs.Add((ushort)(new Random().Next(1,5)));
                    locs.Add(10);

                }

                ActionOperate.GetInstance.Send("SimOrder", locs);
            });

            InitCommand = new RelayCommand(() =>
            {
                ActionOperate.GetInstance.Send("InitCommand");
            });

            LoopSimOrderCommand = new RelayCommand(() =>
            {
                LoopButton = LoopButton == "循环跑单" ? "停止跑单" : "循环跑单";

            });
            //ThreadOperate.GetInstance.StartLong(new Action(() =>
            //{
            //    //try
            //    //{
            //    //    System.Windows.Application.Current.Dispatcher.BeginInvoke((Action)async delegate
            //    //    {
            //    //        if (IsLoop && !IsLoopzc)
            //    //        {
            //    //            IsLoopzc = true;
            //    //            if (simOrderVisibleDatas.ElementAt(0).IsSelected)
            //    //                simOrderVisibleDatas.ElementAt(0).Loc = (ushort)(new Random().Next(1,6));

            //    //            ActionOperate.GetInstance.Send("SimOrder",new SimOrderData()
            //    //            {
            //    //                NoodleLoc = simOrderVisibleDatas.ElementAt(0).Loc,
            //    //                SoupLoc = simOrderVisibleDatas.ElementAt(1).Loc,
            //    //                BowlLoc = 10,
            //    //            });
            //    //            await Task.Delay(50000);
            //    //            IsLoopzc = false;
            //    //        }
            //    //    });

            //    //}
            //    //catch (Exception ex)
            //    //{

            //    //}
            //    Thread.Sleep(1000);
            //}), "循环订单");
        }

        public ObservableCollection<SimOrderVisibleData> simOrderConfig
        {
            get
            {
                if (!Json<KeepDataBase>.Data.simOrderConfig.ContainsKey(GVL.GeneralConfig.DeviceType.ToString()))
                {
                    Json<KeepDataBase>.Data.simOrderConfig.TryAdd(GVL.GeneralConfig.DeviceType.ToString(), new ObservableCollection<SimOrderVisibleData>());
                }
                return Json<KeepDataBase>.Data.simOrderConfig[GVL.GeneralConfig.DeviceType.ToString()];
            }
            set
            {
                if (!Json<KeepDataBase>.Data.simOrderConfig.ContainsKey(GVL.GeneralConfig.DeviceType.ToString()))
                {
                    Json<KeepDataBase>.Data.simOrderConfig.TryAdd(GVL.GeneralConfig.DeviceType.ToString(), new ObservableCollection<SimOrderVisibleData>());
                }
                Json<KeepDataBase>.Data.simOrderConfig[GVL.GeneralConfig.DeviceType.ToString()] = value;
            }
        }



        public static event EventHandler<PropertyChangedEventArgs> StaticPropertyChanged;
        private static void OnStaticPropertyChanged([CallerMemberName] string PropName = "")
        {
            StaticPropertyChanged?.Invoke(null, new PropertyChangedEventArgs(PropName));
        }

        public RelayCommand AddSimDataCommand { get; set; }

        public RelayCommand SimOrderCommand { get; set; }

        public RelayCommand InitCommand { get; set; }

        public RelayCommand LoopSimOrderCommand { get; set; }

        public static bool IsLoop = false;
        public static bool IsLoopzc = false;

        public static string LoopButton
        {
            get { return _LoopButton; }
            set
            {
                _LoopButton = value;
                if (value != "循环跑单") { IsLoop = true; LoopColor = new SolidColorBrush((System.Windows.Media.Color)System.Windows.Media.ColorConverter.ConvertFromString("Red")); }
                else { IsLoop = false; LoopColor = new SolidColorBrush((System.Windows.Media.Color)System.Windows.Media.ColorConverter.ConvertFromString("#00c2f4")); }
                OnStaticPropertyChanged();
            }
        }
        private static string _LoopButton = "循环跑单";
        public static Brush LoopColor { get { return _LoopColor; } set { _LoopColor = value; OnStaticPropertyChanged(); } }
        private static Brush _LoopColor = new SolidColorBrush((System.Windows.Media.Color)System.Windows.Media.ColorConverter.ConvertFromString("#00c2f4"));


    }
}
